<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.1
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class SmfaqsController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{
		// Set a default view if none exists
		if ( ! JRequest::getCmd( 'view' ) ) {
			JRequest::setVar('view', 'category' );
		}

		$layout =  JRequest::getCmd( 'layout' );

		if ($layout == 'form') {
			JError::raiseError( 404, JText::_("Resource Not Found") );
			return;
		}

				
		// View caching logic -- simple... are we logged in?
		$view = JRequest::getVar('view');
		
		parent::display(true);
	}
	
	
	function addquestion()
	{
		$ip = $_SERVER['REMOTE_ADDR'];
		$protecttime = SmfaqsController::_protect($ip);

		if ($protecttime == 'OK') {
			$form = require_once( JPATH_COMPONENT.DS.'views'.DS.'category'.DS.'tmpl'.DS.'form.php' );
		} else { 
			$protecttime =  JHTML::_('date',  $protecttime,  '%d-%m-%Y '. JText::_('in'). '<strong> %H:%M </strong>' );
			echo '<div id="prot">'.JText::_('NEXT_QUESTION').' '.$protecttime.'</div>';
		}

	}
	
	function _protect($ip)
	{
		global $mainframe;
		$db		=& JFactory::getDBO();
		$datenow =& JFactory::getDate();
		$date_now = $datenow->toMySQL();
		$params = $mainframe->getParams();
		$protectInterval = $params->get('prot_time', 0);
		
		$query = "SELECT DATE_ADD(created, INTERVAL " . $protectInterval . " MINUTE)". 
				"\nFROM #__smfaq ".
			    "\nWHERE ip = '$ip' ".
				"\nORDER BY created desc";
				
		$db->setQuery( $query );
		$protecttime = $db->loadResult();
		if ($date_now > $protecttime ) {
			$protecttime = 'OK';
		} else {
		}
			
		return $protecttime;
	}
	
	function send() 
	{
		global $mainframe;
		
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$user = & JFactory::getUser();
		$res['valid'] = false;
		$res['msg'] = '';
		$res['items'] = array();
		$ip = $_SERVER['REMOTE_ADDR'];
		
		$params = &$mainframe->getParams();
		if (!$params->get('smfaqcheck')) {
			$params = &JComponentHelper::getParams( 'com_smfaq' );
		}
		if (($params->get('add_question', 2) > $user->get('aid', 0)) || (SmfaqsController::_protect($ip) !== 'OK'))  {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}
		if ($params->get('show_captcha') > $user->get('aid')) {
			$captcha = JRequest::getVar('captcha');
			if ($captcha !== $_SESSION['captcha-code']) {
				$res['items'][] = array('name' => 'captcha', 'status' => 0, 'msg' => JText::_('WRONG_CAPTCHA'));
				$Validcaptcha = false;
			} else {
				$res['items'][] = array('name' => 'captcha', 'status' => 1);
				$Validcaptcha = true;
			}
		} else {
			$Validcaptcha = true;
		}
		$question = JRequest::getVar('question');
		if(strlen($question) < 5 ) {
		  $res['items'][] = array('name' => 'question', 'status' => 0, 'msg' => JText::_('WRONG_QUESTION'));
		  $Validquestion = false;
		} else {
		  $res['items'][] = array('name' => 'question', 'status' => 1);
		  $Validquestion = true;
		}
		if ($user->guest) {
			$email = JRequest::getVar('email');
			if(strlen($email) < 4 || !preg_match('#^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$#i', $email)) {
			  $res['items'][] = array('name' => 'email', 'status' => 0, 'msg' => JText::_('WRONG_EMAIL'));
			  $Validemail = false;
			} else {
			  $res['items'][] = array('name' => 'email', 'status' => 1);
			  $Validemail = true;
			}
			$name = JRequest::getVar('created_by');
			if (preg_match('/[\"\'\[\]\=\<\>\(\)\;]+/', $name ) || (strlen($name) < 3 )) {
			  $res['items'][] = array('name' => 'created_by', 'status' => 0, 'msg' => JText::_('WRONG_NAME'));
			  $Validname = false;
			} else {
			  $res['items'][] = array('name' => 'created_by', 'status' => 1);
			  $Validname = true;
			}
		} else {
			$Validname = true;
			$Validemail = true;
		}
	  
	  if ($Validname && $Validemail &&  $Validquestion && $Validcaptcha) {
		  $model = $this->getModel('smfaq');
		  $post = JRequest::get('post');
		  $post['ip'] = $ip;
		  
		  $send_mail = JRequest::getInt('send_mail');
		  if ($model->store($post)) {
			  $res['valid'] = true;
			  SmfaqsController::_sendMail();
			  if ($send_mail) {
			  	$res['msg'] = JText::_('FORM_SEND_OK_SUB');
			  } else {
			  	$res['msg'] = JText::_('FORM_SEND_OK');
			  }
			  
		  } else {
			$res['msg'] = $model->getError();
		  }
			  
	  } 
	  echo json_encode($res);
    }
	
	
	
	function _sendMail()
	{
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'route.php');
		global $mainframe;

		$db		=& JFactory::getDBO();
		$datenow =& JFactory::getDate();
		
		$name		= JRequest::getVar( 'created_by',			'',			'post' );
		$question	= JRequest::getVar( 'question',			'',			'post' );
		$created	= JHTML::_('date',  $datenow->toMySQL(),  '%Y-%m-%d %H:%M:%S' );
		$catid  	= JRequest::getVar( 'catid', 0, '', 'int');
		$sitename 		= $mainframe->getCfg( 'sitename' );
		$mailfrom 		= $mainframe->getCfg( 'mailfrom' );
		$fromname 		= $mainframe->getCfg( 'fromname' );
		
		
		$query = 'SELECT c.title' .
				' FROM #__categories AS c' .
				' WHERE c.id = '. (int) $catid;
		$db->setQuery( $query );
		$cattitle = $db->loadResult();
		
		
		$subject = JText::_( 'New question' ). " (" . JText::_( 'Category' ). " - " .$cattitle . " )";
		
		$message = JText::_( 'Asker' ). ': ' . $name . " " . JText::_( 'Date' ). ': ' . $created;
		$message .= "\n\n". JText::_( 'Question' ). ": \n" . $question;
		$message .= "\n\n". JURI::root().SmfaqsHelperRoute::getCategoryRoute($catid);
		
		//get all super administrator
		$query = 'SELECT email, sendEmail' .
				' FROM #__users' .
				' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		
		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message);
			}
		}
	}

	function storevote()
	{
		global $mainframe;
		$userIP =  $_SERVER['REMOTE_ADDR'];
		$id = JRequest::getInt('id');
		$vote_value = JRequest::getInt('vote');
		$db		=& JFactory::getDBO();
		
		$answer = '<strong>'.JText::_('Sanks for vote').'</strong>';
					
		if ($vote_value) {
			$vote_value = 'vote_yes';
		} else {
			$vote_value = 'vote_no';
		}
		
		$query = 'SELECT *' .
				' FROM #__smfaq_votes' .
				' WHERE question_id = '.(int) $id;
		$db->setQuery($query);
		$voting = $db->loadObject();
		
		$cookieName	= JUtility::getHash( $mainframe->getName() . 'smfaq' . (int) $id );
		$voted = JRequest::getVar( $cookieName, '0', 'COOKIE', 'INT');
		
		if (!$voting)
		{
			setcookie( $cookieName, '1');
			// There are no ratings yet, so lets insert our rating
			$query = 'INSERT INTO #__smfaq_votes ( question_id, lastip, '.$vote_value.' )' .
					' VALUES ( '.(int) $id.', '.$db->Quote($userIP).', 1 )';
			$db->setQuery($query);
			if (!$db->query()) {
				JError::raiseError( 500, $db->stderr());
			}
		} else {
			if (($userIP != $voting->lastip) && !$voted)
			{
				setcookie( $cookieName, '1');
				// We weren't the last voter so lets add our vote to the ratings totals for the article
				$query = 'UPDATE #__smfaq_votes' .
						' SET '.$vote_value.' = '.$vote_value.' + 1, lastip = '.$db->Quote($userIP) .
						' WHERE question_id = '.(int) $id;
				$db->setQuery($query);
				if (!$db->query()) {
					JError::raiseError( 500, $db->stderr());
				}
			} else {
				$answer = '<strong>'.JText::_('you voted').'</strong>';
			}
		}
		echo $answer;
	}
	
	function captcha()
	{
		  require_once(JPATH_COMPONENT.DS.'helpers'.DS.'captcha.php');
		  SmfaqsHelperCaptcha::image();
	}

}