<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.0.1
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

$user = & JFactory::getUser();
if ($user->get('gid') < 19 ) {
	JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
}

jimport('joomla.application.component.controller');

class SmfaqsControllerAdmin extends SmfaqsController
{
	
	function edit()
	{
		$user = & JFactory::getUser();
		$view = & $this->getView('smfaq', 'html');
		$model = $this->getModel('smfaq');
		
		if ( $model->isCheckedOut($user->get('id')))
		{
			$msg = JText::sprintf('DESCBEINGEDITTED', JText::_('Question'), $model->get('title'));
			$this->setRedirect(JRoute::_('index.php', false), $msg);
			return;
		}
		
		$view->setModel($model, true);
		$model->checkout();

		$view->display();
	}
	
	function save()	
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$user		=& JFactory::getUser();
		if ($user->get('gid') < 19) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}
		$model = $this->getModel('smfaq');
		$model->checkin();
		$post = JRequest::get('post');
		$post['answer'] = JRequest::getVar('answer', '', 'post', 'string', JREQUEST_ALLOWRAW);
		
		if ($model->store($post)) {	
			$msg = JText::_( 'Greeting Saved!' );
			
			$send_mail = JRequest::getVar( 'send_mail', 0);
			$published = JRequest::getVar( 'published', 0);
			$state     = JRequest::getVar( 'state', 0);
			if ($send_mail && $published && ($state == 2)){
				SmfaqsController::_sendUser();
			}
			$referer = JRequest::getString('ret',  base64_encode(JURI::base()), 'get');
			$referer = base64_decode($referer);
			$this->setRedirect($referer, $msg);
		} else {
			$this->setError($model->getError());
			$this->display();
		}
		
	}
	
	function cancel()
	{
		// Get some objects from the JApplication
		$user	= & JFactory::getUser();

		// Must be logged in
		if ($user->get('id') < 1) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}

		// Checkin the weblink
		$model = $this->getModel('smfaq');
		$model->checkin();

		$referer = JRequest::getString('ret', base64_encode(JURI::base()), 'get');
		$referer = base64_decode($referer);
		if (!JURI::isInternal($referer)) {
			$referer = '';
		}
		$this->setRedirect($referer);
	}

	function delete()
	{
		$user		=& JFactory::getUser();
		
		if ($user->get('gid') < 19) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}
		
		$id = JRequest::getVar('id', 0, '', 'int');
		
		$db			= & JFactory::getDBO();
		$query = 'DELETE FROM #__smfaq' .
				' WHERE id =' . $id;
		$db->setQuery($query);
		
		if (!$db->query())
		{
			JError::raiseError( 500, $db->getErrorMsg() );
			return false;
		}
		
		$referer = JRequest::getString('ret',  base64_encode(JURI::base()), 'get');
		$referer = base64_decode($referer);
		$this->setRedirect($referer, JText::_('Delete successfully'));
	}
	
	function _sendUser()
	{
		require_once(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'route.php');
		global $mainframe;
		
		$SiteName	= $mainframe->getCfg('sitename');
		$email		= JRequest::getVar( 'email',		'',			'post' );
		$question	= JRequest::getVar( 'question',			'',			'post' );
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');
		$catid  	= JRequest::getVar( 'catid', 0, '', 'int');

		$subject	= JText::_( 'Answer question') . " (". $SiteName . " )";
		$body = JText::_('On your question');
		$body .= "\n\n" . $question;
		$body .= "\n\r\n" . JText::_('Published answer');
		$body .= "\n\n". JURI::root().SmfaqsHelperRoute::getCategoryRoute($catid);
		$mail = JFactory::getMailer();
		
		$mail->addRecipient( $email );
		$mail->setSender( array( $MailFrom, $FromName ) );
		$mail->setSubject( $subject );
		$mail->setBody( $body );
		
		$sent = $mail->Send();
	}
	
	function shownoanswer()
	{
		
		$user		=& JFactory::getUser();
		if ($user->get('gid') < 19) {
			JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
			return;
		}
		$catid  	= JRequest::getInt( 'catid', 0);
		$Itemid  	= JRequest::getInt( 'Itemid', 0);
		$ret = 'index.php?option=com_smfaq&view=category&id='.$catid.'&Itemid='.$Itemid; 
		$db		=& JFactory::getDBO();
		$query = 'SELECT id, catid, created, question' .
				' FROM #__smfaq' .
				' WHERE catid ='. (int) $catid . ' AND published = 0' .
				' ORDER BY created';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		
		if ($rows) {
			$html = '<table class="smnopublish" border="1" cellpadding="5">';
			foreach ($rows as $row) {
				$html .= '<tr><td style="text-align:center;">'.JHTML::_('date', $row->created, '%d-%m-%Y %H:%M:%S').'</td>'; 
				$html .= '<td><a title="'.JText::_('Edit').'" href="index.php?option=com_smfaq&controller=admin&task=edit&catid='.$row->catid.'&id='.$row->id.'&ret='. base64_encode($ret) .'">'.$row->question.'</a></td>';
				$html .= '<td><a align="right" href="index.php?option=com_smfaq&controller=admin&task=delete&id='.$row->id.'&ret='. base64_encode($ret) .'" onclick="return confirm(\''. JText::_('Confirm Delete').'\')">
						<img title="'. JText::_( 'Delete' ).'" border="0" alt="'. JText::_( 'Delete' ).'" src="components/com_smfaq/images/delete.png"/></a></td>';
			}
			$html .='</tr></table>';
		} else {
			$html = '<div id="noitems">'.JText::_('Items no found').'</div>';
		}
		echo $html;
	}
}



	

