<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.1
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class SmfaqsModelCategory extends JModel
{
	/**
	 * section id
	 *
	 * @var int
	 */
	var $_id = null;

	/**
	 * section Data array
	 *
	 * @var array
	 */
	var $_data = null;

	/**
	 * section total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * section data
	 *
	 * @var object
	 */
	var $_category = null;

	/**
	 * Pagination object
	 *
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * Constructor
	 *
	 * @since 1.5
	 */
	function __construct()
	{
		parent::__construct();

		global $mainframe;
		
		$config = JFactory::getConfig();
		
		$params = &$mainframe->getParams();
		
		// Get the pagination request variables
		$this->setState('limit', $mainframe->getUserStateFromRequest('com_smfaq.limit', 'limit', $params->get('display_num'), 'int'));
		$this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));

		// In case limit has been changed, adjust limitstart accordingly
		$this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) : 0));

		
		$id = JRequest::getVar('id', 0, '', 'int');
		$this->setId((int)$id);
	}

	function setId($id)
	{
		// Set section ID and wipe data
		$this->_id			= $id;
		$this->_category	= null;
		$this->_data		= array();
	}

	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

			$total = count($this->_data);
			for($i = 0; $i < $total; $i++)
			{
				$item =& $this->_data[$i];
			}
		}
		
		return $this->_data;
	}
	
	/**
	 * Method to get the total number of weblink items for the section
	 * @return integer
	 */
	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}


	/**
	 * Method to get section data for the current section
	 *
	 * @since 1.5
	 */
	function getCategory()
	{
		// Load the Category data
		if ($this->_loadCategory()) {
			// Initialize some variables
			$user = &JFactory::getUser();
//		    Make sure the category is published
			if (!$this->_category->published) {
				JError::raiseError(404, JText::_("Resource Not Found"));
				return false;
			}
			// check whether category access level allows access
			if ($this->_category->access > $user->get('aid', 0)) {
				JError::raiseError(403, JText::_("ALERTNOTAUTH"));
				return false;
			}
		}
		return $this->_category;
	}
   /**
	* Method to load category data if it doesn't exist.
	*
	* @access private
	* @return boolean True on success
	*/
	function _loadCategory()
	{
		if (empty($this->_category)) {
			// current category info
			$query = 'SELECT c.*, ' .
			' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as slug '.
			' FROM #__categories AS c' .
			' WHERE c.id = '. (int) $this->_id .
			' AND c.section = "com_smfaq"';
			$this->_db->setQuery($query, 0, 1);
			$this->_category = $this->_db->loadObject();
		}
		return true;
	}
	
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		// We need to get a list of all weblinks in the given section
		$query = 'SELECT a.*' .
			' FROM #__smfaq AS a' . 
			$where .
			$orderby;

		return $query;
	}
	
	function _buildContentWhere()
	{
		$where = ' WHERE a.catid = '. (int) $this->_id. ' AND a.published = 1 ';
		return $where;
	}
	
	function _buildContentOrderBy()
	{
		global $mainframe;
		$user = &JFactory::getUser();
		$params = &$mainframe->getParams();
		if (!$params->get('smfaqcheck')) {
			$params = &JComponentHelper::getParams( 'com_smfaq' );
		}

		$orderby = ' ORDER BY ';
		
		switch ($params->get('order_question'))
		{
			case '1':
				$orderby .= 'a.created desc';
				break;
			case '2':
				$orderby .= 'a.created asc';
				break;
			case '3':
				$orderby .= 'a.question asc';
				break;
			case '0':
			default:
				$orderby .= 'a.ordering';
				break;
		}

		return $orderby;
	}
}
