<?php
/**
* @version		$Id: mod_cleanmenu.php 2009-12-01 
* @license		GNU/GPL, see LICENSE.php
* Cleanmenu for Joomla+Virtuemart is free software. This version may have been 
* modified pursuant to the GNU General Public License, and as distributed it 
* includes or is derivative of works licensed under the GNU General Public 
* License or other free or open source software licenses.
*
* http://www.greenkey.ru
*/

// no direct access
defined('_JEXEC') or die('Restricted access');


jimport('joomla.base.tree');
jimport('joomla.utilities.simplexml');

if( file_exists(dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' )) {
	require_once( dirname(__FILE__).'/../../components/com_virtuemart/virtuemart_parser.php' );
	$mosConfig_absolute_path = realpath( dirname(__FILE__).'/../..' );
} else {
	require_once( dirname(__FILE__).'/../components/com_virtuemart/virtuemart_parser.php' );
}
require_once(CLASSPATH.'ps_product_category.php');

/**
 * mod_cleanmenu Helper class
 *
 * @static
 * @package		Joomla
 * @subpackage	Menus
 * @since		1.5
 **/

$categories = Array();
$i = 0;

class modCleanMenuHelper
{

	function recurse_cat_tree($cat_id, $cats, $parent_id, $parent_menu)
	{
		global $categories, $i;

		$no_childrens = 0;
		foreach ($cats as $line)
		{
			if ($line["category_parent_id"] == $cat_id)
			{
				if ($no_childrens == 0) 
				{ 
					if ($parent_menu == 0) $categories[$i]["class"] = "fly"; 
					$no_childrens = 1; 
				};
				$i++;
				$categories[$i]["category_id"] = $line["category_id"];
				$categories[$i]["category_name"] = $line["category_name"];
				$categories[$i]["category_parent_id"] = $line["category_parent_id"];
				$categories[$i]["parent_id"] = $parent_id;
				$categories[$i]["parent_menu"] = $parent_menu;
				//echo $line["category_name"];
				modCleanMenuHelper::recurse_cat_tree($line["category_id"], $cats, $i, 0, "not_first");
			}
		}
	}
	
	function buildXML(&$params)
	{
		global $VM_LANG, $categories, $i;
		
		$menu = new JSimpleTree($params);
		$items = &JSite::getMenu();

		// Get Menu Items
		$rows = $items->getItems('menutype', $params->get('menutype'));
		$maxdepth = $params->get('maxdepth',10);
		$max_index = 0;
		
		foreach ($rows as $key => $rowline) 
		{
			//echo $rowline->link.'-'; 
			if ($max_index < $rowline->id) $max_index = $rowline->id;
			$rowparam = new JParameter( $rowline->params );
			$start_cat = $rowparam->get('category_id',-1);

			if ($start_cat >= 0)
			{
				/*foreach ($rowline as $k => $lav)
				{
					echo $k.'-'.$lav."! <br/>";
					$virt_row[$k] = $lav;
				}*/

				$q = "SELECT c.category_id, c.category_name, x.category_parent_id FROM ".
					"#__{vm}_category AS c LEFT JOIN #__{vm}_category_xref AS x ".
					"ON c.category_id = x.category_child_id";
	
				$db = new ps_DB;
				$db->setQuery($q);   
				$db->query();
				$j = 0; $cats = Array();
				while( $db->next_record() ) 
				{
					$j++;
					$cats[$j]["category_id"] = $db->f("category_id");
					$cats[$j]["category_name"] = $db->f("category_name");
					$cats[$j]["category_parent_id"] = $db->f("category_parent_id");
					//echo $cats[$i]["category_name"];
				}
				modCleanMenuHelper::recurse_cat_tree($start_cat, $cats, $i, $rowline->id);
			};
		};
		
		foreach ($categories as $j => $rowline)
		{
			
			//echo $rowline["category_id"].' ';
			//echo $rowline["category_name"].' ';
			//echo $rowline["category_parent_id"].' ';
			//echo $rowline["parent_id"].' ';
			//echo $rowline["parent_menu"].' <br/>';
			$virt_row->id = $max_index + $j;
			$virt_row->menutype = "catalog";
			$virt_row->name = $rowline['category_name'];
			$virt_row->alias = "catalog_".$rowline["category_id"];
			$virt_row->link = "index.php?option=com_virtuemart&page=shop.browse&category_id=".$rowline["category_id"];
			$virt_row->type = "component";
			$virt_row->published = 1;
			if ($rowline["parent_menu"] > 0)
			{
				$virt_row->parent = $rowline["parent_menu"];
			} else
			{
				$virt_row->parent = $max_index+$rowline['parent_id'];
			}
			$virt_row->componentid = 41;
			$virt_row->sublevel = 1;
			$virt_row->ordering = 1;
			$virt_row->checked_out = 0;
			$virt_row->pollid = 0;
			$virt_row->browserNav = 0;
			$virt_row->access = 0;
			$virt_row->utaccess = 0;
			$virt_row->params = "";
			$virt_row->lft = 0;
			$virt_row->rgt = 0;
			$virt_row->home = 0;
			$virt_row->has_child = $rowline['class'];
			//echo $virt_row->id.'--'.$virt_row->name.'-'.$virt_row->parent.'<br/>';
			array_push($rows, $virt_row);
			$virt_row = Null;
		}

		// Build Menu Tree root down (orphan proof - child might have lower id than parent)
		$user =& JFactory::getUser();
		$ids = array();
		$ids[0] = true;
		$last = null;
		$unresolved = array();
		// pop the first item until the array is empty if there is any item
		if ( is_array($rows)) {
			while (count($rows) && !is_null($row = array_shift($rows)))
			{
				if (array_key_exists($row->parent, $ids)) {
					$row->ionly = $params->get('menu_images_link');
					$menu->addNode($params, $row);

					// record loaded parents
					$ids[$row->id] = true;
				} else {
					// no parent yet so push item to back of list
					// SAM: But if the key isn't in the list and we dont _add_ this is infinite, so check the unresolved queue
					if(!array_key_exists($row->id, $unresolved) || $unresolved[$row->id] < $maxdepth) {
						array_push($rows, $row);
						// so let us do max $maxdepth passes
						// TODO: Put a time check in this loop in case we get too close to the PHP timeout
						if(!isset($unresolved[$row->id])) $unresolved[$row->id] = 1;
						else $unresolved[$row->id]++;
					}
				}
			}
		}
		return $menu->toXML();
	}

	function &getXML($type, &$params, $decorator)
	{
		static $xmls;

		if (!isset($xmls[$type])) {
			$cache =& JFactory::getCache('mod_cleanmenu');
			$string = $cache->call(array('modCleanMenuHelper', 'buildXML'), $params);
			$xmls[$type] = $string;
		}

		// Get document
		$xml = JFactory::getXMLParser('Simple');
		$xml->loadString($xmls[$type]);
		$doc = &$xml->document;

		$menu	= &JSite::getMenu();
		$active	= $menu->getActive();
		$start	= $params->get('startLevel');
		$end	= $params->get('endLevel');
		$sChild	= $params->get('showAllChildren');
		$path	= array();

		// Get subtree
		if ($start)
		{
			$found = false;
			$root = true;
			if(!isset($active)){
				$doc = false;
			}
			else{
				$path = $active->tree;
				for ($i=0,$n=count($path);$i<$n;$i++)
				{
					foreach ($doc->children() as $child)
					{
						if ($child->attributes('id') == $path[$i]) {
							$doc = &$child->ul[0];
							$root = false;
							break;
						}
					}

					if ($i == $start-1) {
						$found = true;
						break;
					}
				}
				if ((!is_a($doc, 'JSimpleXMLElement')) || (!$found) || ($root)) {
					$doc = false;
				}
			}
		}

		if ($doc && is_callable($decorator)) {
			$doc->map($decorator, array('end'=>$end, 'children'=>$sChild));
		}
		return $doc;
	}

	function render(&$params, $callback)
	{
		switch ( $params->get( 'menu_style', 'list' ) )
		{
			case 'list_flat' :
				// Include the legacy library file
				// No another than real list supported now
				require_once(dirname(__FILE__).DS.'legacy.php');
				mosShowHFMenu($params, 1);
				break;

			default :
				// Include the new menu class
				$xml = modCleanMenuHelper::getXML($params->get('menutype'), $params, $callback);
				if ($xml) {
					$class = $params->get('class_sfx');
					$xml->addAttribute('class', $class);
					if ($tagId = $params->get('tag_id')) {
						$xml->addAttribute('id', $tagId);
					}

					$result = JFilterOutput::ampReplace($xml->toString((bool)$params->get('show_whitespace')));
					$result = str_replace(array('<ul/>', '<ul />'), '', $result);
					echo $result;
				}
				break;
		}
	}
}

/**
 * Main Menu Tree Class.
 *
 */
class JSimpleTree extends JTree
{
	/**
	 * Node/Id Hash for quickly handling node additions to the tree.
	 */
	var $_nodeHash = array();

	/**
	 * Menu parameters
	 */
	var $_params = null;

	/**
	 * Menu parameters
	 */
	var $_buffer = null;

	function __construct(&$params)
	{
		$this->_params		=& $params;
		$this->_root		= new JSimpleNode(0, 'ROOT');
		$this->_nodeHash[0]	=& $this->_root;
		$this->_current		=& $this->_root;
	}

	function addNode(&$params, $item)
	{
		// Get menu item data
		$data = $this->_getItemData($params, $item);

		// Create the node and add it
		$node = new JSimpleNode($item->id, $item->name, $item->access, $data);

		if (isset($item->mid)) {
			$nid = $item->mid;
		} else {
			$nid = $item->id;
		}
		$this->_nodeHash[$nid] =& $node;
		$this->_current =& $this->_nodeHash[$item->parent];

		if ($item->type == 'menulink' && !empty($item->query['Itemid'])) {
			$node->mid = $item->query['Itemid'];
		}

		if ($this->_current) {
			$this->addChild($node, true);
		} else {
			// sanity check
			JError::raiseError( 500, 'Orphan Error. Could not find parent for Item '.$item->id );
		}
	}

	function toXML()
	{
		// Initialize variables
		$this->_current =& $this->_root;

		// Recurse through children if they exist
		while ($this->_current->hasChildren())
		{
			$this->_buffer .= '<ul>';
			foreach ($this->_current->getChildren() as $child)
			{
				$this->_current = & $child;
				$this->_getLevelXML(0);
			}
			$this->_buffer .= '</ul>';
		}
		if($this->_buffer == '') { $this->_buffer = '<ul />'; }
		return $this->_buffer;
	}

	function _getLevelXML($depth)
	{
		$depth++;
		
		// Start the item
		$rel = (!empty($this->_current->mid)) ? ' rel="'.$this->_current->mid.'"' : '';
		$this->_buffer .= '<li access="'.$this->_current->access.'" level="'.$depth.'" id="'.$this->_current->id.'"'.$rel.' '.(($depth == 1) ? 'class="top" ' : '').'>';

		// Append item data
		$this->_buffer .= $this->_current->link;

		// Recurse through item's children if they exist
		while ($this->_current->hasChildren())
		{
			$this->_buffer .= '<ul '.(($depth == 1) ? 'class="sub"' : '').'>';
			foreach ($this->_current->getChildren() as $child)
			{
				$this->_current = & $child;
				$this->_getLevelXML($depth);
			}
			$this->_buffer .= '</ul>';
		}

		// Finish the item
		$this->_buffer .= '</li>';
	}

	function _getItemData(&$params, $item)
	{
		$data = null;

		// Menu Link is a special type that is a link to another item
		if ($item->type == 'menulink')
		{
			$menu = &JSite::getMenu();
			if ($newItem = $menu->getItem($item->query['Itemid'])) {
    			$tmp = clone($newItem);
				$tmp->mid	 = $item->id;
				$tmp->parent = $item->parent;
				if ($tmp->parent == 0) 
					$tmp->name	 = '<span class="down"><![CDATA['.$item->name.']]></span>';
				else
					$tmp->name	 = '<![CDATA['.$item->name.']]>';
			} else {
				return false;
			}
		} else {
			$tmp = clone($item);
			if ($tmp->parent == 0) 
				$tmp->name = '<span class="down"><![CDATA['.$item->name.']]></span>';
			else 
				$tmp->name = '<![CDATA['.$item->name.']]>';
		}

		$iParams = new JParameter($tmp->params);
		if ($params->get('menu_images') && $iParams->get('menu_image') && $iParams->get('menu_image') != -1) {
			$imgalign = $params->get('menu_images_align', 0) == 1 ? 'right' : 'left';
			$image = '<img src="'.JURI::base(true).'/images/stories/'.$iParams->get('menu_image').'" align="'.$imgalign.'" alt="'.$item->alias.'" />';
			if($tmp->ionly){
				 $tmp->name = null;
			 }
		} else {
			$image = null;
		}
		switch ($tmp->type)
		{
			case 'separator' :
				return '<a class="menuitem" style="cursor:hand;">'.$image.$tmp->name.'</a>';
				break;

			case 'url' :
				if ((strpos($tmp->link, 'index.php?') === 0) && (strpos($tmp->link, 'Itemid=') === false)) {
					$tmp->url = $tmp->link.'&amp;Itemid='.$tmp->id;
				} else {
					$tmp->url = $tmp->link;
				}
				break;

			default :
				$router = JSite::getRouter();
				//$tmp->url = $router->getMode() == JROUTER_MODE_SEF ? 'index.php?Itemid='.$tmp->id : $tmp->link.'&Itemid='.$tmp->id;
				$tmp->url = $tmp->link.'&Itemid='.$tmp->id;
				break;
		}

		// Print a link if it exists
		if ($tmp->url != null)
		{
			// Handle SSL links
			$iSecure = $iParams->def('secure', 0);
			if ($tmp->home == 1) {
				$tmp->url = JURI::base();
			} elseif (strcasecmp(substr($tmp->url, 0, 4), 'http') && (strpos($tmp->link, 'index.php?') !== false)) {
				$tmp->url = JRoute::_($tmp->url, true, $iSecure);
			} else {
				$tmp->url = str_replace('&', '&amp;', $tmp->url);
			}

			switch ($tmp->browserNav)
			{
				default:
				case 0:
					// _top
					$data = '<a href="'.$tmp->url.'" '.(($tmp->parent == 0) ? 'class="top_link" ' : 'class="'.$tmp->has_child.'"').'>'.$image.$tmp->name.'</a>';
					break;
				case 1:
					// _blank
					$data = '<a href="'.$tmp->url.'" target="_blank">'.$image.$tmp->name.'</a>';
					break;
				case 2:
					// window.open
					$attribs = 'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,'.$this->_params->get('window_open');

					// hrm...this is a bit dickey
					$link = str_replace('index.php', 'index2.php', $tmp->url);
					$data = '<a href="'.$link.'" onclick="window.open(this.href,\'targetWindow\',\''.$attribs.'\');return false;">'.$image.$tmp->name.'</a>';
					break;
			}
		} else {
			$data = '<a>'.$image.$tmp->name.'</a>';
		}

		return $data;
	}
}

/**
 * Main Menu Tree Node Class.
 *
 */
class JSimpleNode extends JNode
{
	/**
	 * Node Title
	 */
	var $title = null;

	/**
	 * Node Link
	 */
	var $link = null;

	/**
	 * CSS Class for node
	 */
	var $class = null;

	function __construct($id, $title, $access = null, $link = null, $class = null)
	{
		$this->id		= $id;
		$this->title	= $title;
		$this->access	= $access;
		$this->link		= $link;
		$this->class	= $class;
	}
}
